﻿using System.Linq;
using Infragistics.Win;
using System.Collections.Generic;
using Infragistics.Win.UltraWinGrid;
using System.Drawing;

namespace WG_SyncMultipleGrids
{
    internal class CustomDrawFilter : IUIElementDrawFilter
    {
        private List<int> positions = new List<int>();

        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            if (drawParams.Element is UltraGridUIElement)
            {
                if (drawPhase == DrawPhase.BeforeDrawChildElements)
                {
                    positions.Clear();
                }
                else
                {
                    foreach (var position in positions)
                    {
                        drawParams.Graphics.DrawLine(Pens.Red, new Point(position, drawParams.Element.Rect.Top),
                                                               new Point(position, drawParams.Element.Rect.Bottom));
                    }
                }
            }
            else
            {
                positions.Add(drawParams.Element.Rect.Right);
            }
            return false;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            if (drawParams.Element is UltraGridUIElement)
                return DrawPhase.BeforeDrawChildElements | DrawPhase.AfterDrawChildElements;

            else if (drawParams.Element is HeaderUIElement)
                return DrawPhase.BeforeDrawElement;

            else
                return DrawPhase.None;

        }
    }
}